Bug 625973

Summary: Regression in new qemu-img (backing image format not detected)
Product: [Fedora] Fedora Reporter: Tobias Mueller <fedora-bugs>
Component: qemuAssignee: Fedora Virtualization Maintainers <virt-maint>
Status: CLOSED WONTFIX QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: low    
Version: 18CC: amit.shah, berrange, crobinso, dwmw2, ehabkost, itamar, jaswinder, jforbes, knoel, ondrejj, scottt.tw, tburke, virt-maint
Target Milestone: ---   
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2013-07-11 15:37:13 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:

Description Tobias Mueller 2010-08-20 23:53:10 EDT
Description of problem:
$ qemu-img create -f qcow2 /tmp/test.qcow2 1GB
Formatting '/tmp/test.qcow2', fmt=qcow2 size=1073741824 encryption=off cluster_size=0 
$ qemu-img create -o backing_file=/tmp/test.qcow2 /tmp/test.new.qcow2
Unknown option 'backing_file'
qemu-img: Invalid options for file format 'raw'.
$ 

The old qemu=img was capable of detecting the source format.
Now, one has to manually give -f qcow2.

Version-Release number of selected component (if applicable):
Name        : qemu-img
Arch        : x86_64
Epoch       : 2
Version     : 0.13.0
Release     : 0.5.20100809git25fdf4a.fc13
Size        : 560 k
Repo        : installed
From repo   : rawvirt
Summary     : QEMU command line tool for manipulating disk images
URL         : http://www.qemu.org/
License     : GPLv2+ and LGPLv2+ and BSD
Description : This package provides a command line tool for manipulating disk
            : images
Comment 1 Bug Zapper 2011-06-01 06:58:39 EDT
This message is a reminder that Fedora 13 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 13.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '13'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 13's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 13 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 2 Tobias Mueller 2011-06-25 12:19:14 EDT
Still an issue with F14
Comment 3 Cole Robinson 2012-05-20 18:32:39 EDT
I can reproduce with upstream. Moving this to rawhide.
Comment 4 Fedora End Of Life 2013-07-04 01:34:42 EDT
This message is a reminder that Fedora 17 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 17. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '17'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 17's end of life.

Bug Reporter:  Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 17 is end of life. If you 
would still like  to see this bug fixed and are able to reproduce it 
against a later version  of Fedora, you are encouraged  change the 
'version' to a later Fedora version prior to Fedora 17's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 5 Cole Robinson 2013-07-11 15:37:13 EDT
So I looked at this a bit, and fixing it is non trivial.

qemu-img and the block layer have changed a _ton_ since qemu 0.13. nowadays, things are structured like 1) have a format 2) lookup options applicable for that format 3) validate passed options match that format. In order to restore the old behavior in a consistent way for -o _and_ -b, we'd likely need to add infrastructure to find a matching format based on what was passed. Not impossible, but also facilitates only a small convenience and code would need to be added to the block layer since this functionality is shared about multiple entry points.

Given that this regressed 3+ years ago and there hasn't been much noise about it, I don't expect it to ever be fixed. You can try your luck with an upstream bug, but it likely won't be fixed unless someone decides to scratch their own itch.